ICU 74.2: icu::SimpleDateFormat Class Reference

ICU 74.2 74.2

Data Structures | Public Member Functions | Static Public Member Functions | Friends
icu::SimpleDateFormat Class Reference

SimpleDateFormat is a concrete class for formatting and parsing dates in a language-independent manner. More...

`#include <smpdtfmt.h>`

Inheritance diagram for icu::SimpleDateFormat:

## Public Member Functions
| SimpleDateFormat (UErrorCode &status)
| Construct a SimpleDateFormat using the default pattern for the default locale.
| SimpleDateFormat (const UnicodeString &pattern, UErrorCode &status)
| Construct a SimpleDateFormat using the given pattern and the default locale.
| SimpleDateFormat (const UnicodeString &pattern, const UnicodeString &override, UErrorCode &status)
| Construct a SimpleDateFormat using the given pattern, numbering system override, and the default locale.
| SimpleDateFormat (const UnicodeString &pattern, const Locale &locale, UErrorCode &status)
| Construct a SimpleDateFormat using the given pattern and locale.
| SimpleDateFormat (const UnicodeString &pattern, const UnicodeString &override, const Locale &locale, UErrorCode &status)
| Construct a SimpleDateFormat using the given pattern, numbering system override, and locale.
| SimpleDateFormat (const UnicodeString &pattern, DateFormatSymbols *formatDataToAdopt, UErrorCode &status)
| Construct a SimpleDateFormat using the given pattern and locale-specific symbol data.
| SimpleDateFormat (const UnicodeString &pattern, const DateFormatSymbols &formatData, UErrorCode &status)
| Construct a SimpleDateFormat using the given pattern and locale-specific symbol data.
| SimpleDateFormat (const SimpleDateFormat &)
| Copy constructor.
SimpleDateFormat & | operator= (const SimpleDateFormat &)
| Assignment operator.
virtual | ~SimpleDateFormat ()
| Destructor.
virtual SimpleDateFormat * | clone () const override
| Clone this Format object polymorphically.
virtual bool | operator== (const Format &other) const override
| Return true if the given Format objects are semantically equal.
virtual UnicodeString & | format (Calendar &cal, UnicodeString &appendTo, FieldPosition &pos) const override
| Format a date or time, which is the standard millis since 24:00 GMT, Jan 1, 1970.
virtual UnicodeString & | format (Calendar &cal, UnicodeString &appendTo, FieldPositionIterator *posIter, UErrorCode &status) const override
| Format a date or time, which is the standard millis since 24:00 GMT, Jan 1, 1970.
virtual void | parse (const UnicodeString &text, Calendar &cal, ParsePosition &pos) const override
| Parse a date/time string beginning at the given parse position.
virtual void | set2DigitYearStart (UDate d, UErrorCode &status)
| Set the start UDate used to interpret two-digit year strings.
UDate | get2DigitYearStart (UErrorCode &status) const
| Get the start UDate used to interpret two-digit year strings.
virtual UnicodeString & | toPattern (UnicodeString &result) const
| Return a pattern string describing this date format.
virtual UnicodeString & | toLocalizedPattern (UnicodeString &result, UErrorCode &status) const
| Return a localized pattern string describing this date format.
virtual void | applyPattern (const UnicodeString &pattern)
| Apply the given unlocalized pattern string to this date format.
virtual void | applyLocalizedPattern (const UnicodeString &pattern, UErrorCode &status)
| Apply the given localized pattern string to this date format.
virtual const DateFormatSymbols * | getDateFormatSymbols (void) const
| Gets the date/time formatting symbols (this is an object carrying the various strings and other symbols used in formatting: e.g., month names and abbreviations, time zone names, AM/PM strings, etc.)
virtual void | adoptDateFormatSymbols (DateFormatSymbols *newFormatSymbols)
| Set the date/time formatting symbols.
virtual void | setDateFormatSymbols (const DateFormatSymbols &newFormatSymbols)
| Set the date/time formatting data.
virtual UClassID | getDynamicClassID (void) const override
| Returns a unique class ID POLYMORPHICALLY.
virtual void | adoptCalendar (Calendar *calendarToAdopt) override
| Set the calendar to be used by this date format.
virtual void | adoptTimeZoneFormat (TimeZoneFormat *timeZoneFormatToAdopt)
| Sets the TimeZoneFormat to be used by this date/time formatter.
virtual void | setTimeZoneFormat (const TimeZoneFormat &newTimeZoneFormat)
| Sets the TimeZoneFormat to be used by this date/time formatter.
virtual const TimeZoneFormat * | getTimeZoneFormat (void) const
| Gets the time zone format object associated with this date/time formatter.
virtual void | setContext (UDisplayContext value, UErrorCode &status) override
| Set a particular UDisplayContext value in the formatter, such as UDISPCTX_CAPITALIZATION_FOR_STANDALONE.
void | adoptNumberFormat (NumberFormat *formatToAdopt) override
| Overrides base class method and This method clears per field NumberFormat instances previously set by {.
void | adoptNumberFormat (const UnicodeString &fields, NumberFormat *formatToAdopt, UErrorCode &status)
| Allow the user to set the NumberFormat for several fields It can be a single field like: "y"(year) or "M"(month) It can be several field combined together: "yM"(year and month) Note: 1 symbol field is enough for multiple symbol field (so "y" will override "yy", "yyy") If the field is not numeric, then override has no effect (like "MMM" will use abbreviation, not numerical field) Per field NumberFormat can also be cleared in {.
const NumberFormat * | getNumberFormatForField (char16_t field) const
| Get the numbering system to be used for a particular field.
UBool | isFieldUnitIgnored (UCalendarDateFields field) const
| This is for ICU internal use only.
const Locale & | getSmpFmtLocale (void) const
| This is for ICU internal use only.
virtual UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, FieldPosition &pos, UErrorCode &status) const override
| Format an object to produce a string.
virtual UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, FieldPositionIterator *posIter, UErrorCode &status) const override
| Format an object to produce a string.
virtual UnicodeString & | format (Calendar &cal, UnicodeString &appendTo, FieldPosition &fieldPosition) const=0
| Formats a date into a date/time string.
virtual UnicodeString & | format (Calendar &cal, UnicodeString &appendTo, FieldPositionIterator *posIter, UErrorCode &status) const
| Formats a date into a date/time string.
UnicodeString & | format (UDate date, UnicodeString &appendTo, FieldPosition &fieldPosition) const
| Formats a UDate into a date/time string.
UnicodeString & | format (UDate date, UnicodeString &appendTo, FieldPositionIterator *posIter, UErrorCode &status) const
| Formats a UDate into a date/time string.
UnicodeString & | format (UDate date, UnicodeString &appendTo) const
| Formats a UDate into a date/time string.
UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, UErrorCode &status) const
| Formats an object to produce a string.
virtual UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, FieldPosition &pos, UErrorCode &status) const =0
| Format an object to produce a string.
virtual UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, FieldPositionIterator *posIter, UErrorCode &status) const
| Format an object to produce a string.
virtual UDate | parse (const UnicodeString &text, UErrorCode &status) const
| Parse a date/time string.
virtual void | parse (const UnicodeString &text, Calendar &cal, ParsePosition &pos) const=0
| Parse a date/time string beginning at the given parse position.
UDate | parse (const UnicodeString &text, ParsePosition &pos) const
| Parse a date/time string beginning at the given parse position.
Public Member Functions inherited from icu::DateFormat
virtual | ~DateFormat ()
| Destructor.
virtual DateFormat * | clone () const override=0
| Clones this object polymorphically.
virtual bool | operator== (const Format &) const override
| Equality operator.
virtual UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, FieldPosition &pos, UErrorCode &status) const override
| Format an object to produce a string.
virtual UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, FieldPositionIterator *posIter, UErrorCode &status) const override
| Format an object to produce a string.
virtual UnicodeString & | format (Calendar &cal, UnicodeString &appendTo, FieldPosition &fieldPosition) const =0
| Formats a date into a date/time string.
virtual UnicodeString & | format (Calendar &cal, UnicodeString &appendTo, FieldPositionIterator *posIter, UErrorCode &status) const
| Formats a date into a date/time string.
UnicodeString & | format (UDate date, UnicodeString &appendTo, FieldPosition &fieldPosition) const
| Formats a UDate into a date/time string.
UnicodeString & | format (UDate date, UnicodeString &appendTo, FieldPositionIterator *posIter, UErrorCode &status) const
| Formats a UDate into a date/time string.
UnicodeString & | format (UDate date, UnicodeString &appendTo) const
| Formats a UDate into a date/time string.
virtual UDate | parse (const UnicodeString &text, UErrorCode &status) const
| Parse a date/time string.
virtual void | parse (const UnicodeString &text, Calendar &cal, ParsePosition &pos) const =0
| Parse a date/time string beginning at the given parse position.
UDate | parse (const UnicodeString &text, ParsePosition &pos) const
| Parse a date/time string beginning at the given parse position.
virtual void | parseObject (const UnicodeString &source, Formattable &result, ParsePosition &parse_pos) const override
| Parse a string to produce an object.
virtual UBool | isLenient (void) const
| Returns whether both date/time parsing in the encapsulated Calendar object and DateFormat whitespace & numeric processing is lenient.
virtual void | setLenient (UBool lenient)
| Specifies whether date/time parsing is to be lenient.
virtual UBool | isCalendarLenient (void) const
| Returns whether date/time parsing in the encapsulated Calendar object processing is lenient.
virtual void | setCalendarLenient (UBool lenient)
| Specifies whether encapsulated Calendar date/time parsing is to be lenient.
virtual const Calendar * | getCalendar (void) const
| Gets the calendar associated with this date/time formatter.
virtual void | adoptCalendar (Calendar *calendarToAdopt)
| Set the calendar to be used by this date format.
virtual void | setCalendar (const Calendar &newCalendar)
| Set the calendar to be used by this date format.
virtual const NumberFormat * | getNumberFormat (void) const
| Gets the number formatter which this date/time formatter uses to format and parse the numeric portions of the pattern.
virtual void | adoptNumberFormat (NumberFormat *formatToAdopt)
| Allows you to set the number formatter.
virtual void | setNumberFormat (const NumberFormat &newNumberFormat)
| Allows you to set the number formatter.
virtual const TimeZone & | getTimeZone (void) const
| Returns a reference to the TimeZone used by this DateFormat's calendar.
virtual void | adoptTimeZone (TimeZone *zoneToAdopt)
| Sets the time zone for the calendar of this DateFormat object.
virtual void | setTimeZone (const TimeZone &zone)
| Sets the time zone for the calendar of this DateFormat object.
virtual void | setContext (UDisplayContext value, UErrorCode &status)
| Set a particular UDisplayContext value in the formatter, such as UDISPCTX_CAPITALIZATION_FOR_STANDALONE.
virtual UDisplayContext | getContext (UDisplayContextType type, UErrorCode &status) const
| Get the formatter's UDisplayContext value for the specified UDisplayContextType, such as UDISPCTX_TYPE_CAPITALIZATION.
virtual DateFormat & | setBooleanAttribute (UDateFormatBooleanAttribute attr, UBool newvalue, UErrorCode &status)
| Sets an boolean attribute on this DateFormat.
virtual UBool | getBooleanAttribute (UDateFormatBooleanAttribute attr, UErrorCode &status) const
| Returns a boolean from this DateFormat May return U_UNSUPPORTED_ERROR if this instance does not support the specified attribute.
UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, UErrorCode &status) const
| Formats an object to produce a string.
virtual UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, FieldPosition &pos, UErrorCode &status) const=0
| Format an object to produce a string.
virtual UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, FieldPositionIterator *posIter, UErrorCode &status) const
| Format an object to produce a string.
Public Member Functions inherited from icu::Format
virtual | ~Format ()
| Destructor.
virtual bool | operator== (const Format &other) const =0
| Return true if the given Format objects are semantically equal.
bool | operator!= (const Format &other) const
| Return true if the given Format objects are not semantically equal.
virtual Format * | clone () const =0
| Clone this object polymorphically.
UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, UErrorCode &status) const
| Formats an object to produce a string.
virtual UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, FieldPosition &pos, UErrorCode &status) const =0
| Format an object to produce a string.
virtual UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, FieldPositionIterator *posIter, UErrorCode &status) const
| Format an object to produce a string.
virtual void | parseObject (const UnicodeString &source, Formattable &result, ParsePosition &parse_pos) const =0
| Parse a string to produce an object.
void | parseObject (const UnicodeString &source, Formattable &result, UErrorCode &status) const
| Parses a string to produce an object.
Locale | getLocale (ULocDataLocaleType type, UErrorCode &status) const
| Get the locale for this format object.
const char * | getLocaleID (ULocDataLocaleType type, UErrorCode &status) const
| Get the locale for this format object.
Public Member Functions inherited from icu::UObject
virtual | ~UObject ()
| Destructor.
virtual UClassID | getDynamicClassID () const
| ICU4C "poor man's RTTI", returns a UClassID for the actual ICU class.

## Static Public Member Functions
static UClassID | getStaticClassID (void)
| Return the class ID for this class.
static UBool | isFieldUnitIgnored (const UnicodeString &pattern, UCalendarDateFields field)
| This is for ICU internal use only.
Static Public Member Functions inherited from icu::DateFormat
static DateFormat * | createInstance (void)
| Create a default date/time formatter that uses the SHORT style for both the date and the time.
static DateFormat * | createTimeInstance (EStyle style=kDefault, const Locale &aLocale=Locale::getDefault())
| Creates a time formatter with the given formatting style for the given locale.
static DateFormat * | createDateInstance (EStyle style=kDefault, const Locale &aLocale=Locale::getDefault())
| Creates a date formatter with the given formatting style for the given const locale.
static DateFormat * | createDateTimeInstance (EStyle dateStyle=kDefault, EStyle timeStyle=kDefault, const Locale &aLocale=Locale::getDefault())
| Creates a date/time formatter with the given formatting styles for the given locale.
static UnicodeString | getBestPattern (const Locale &locale, const UnicodeString &skeleton, UErrorCode &status)
| Returns the best pattern given a skeleton and locale.
static DateFormat * | createInstanceForSkeleton (const UnicodeString &skeleton, UErrorCode &status)
| Creates a date/time formatter for the given skeleton and default locale.
static DateFormat * | createInstanceForSkeleton (const UnicodeString &skeleton, const Locale &locale, UErrorCode &status)
| Creates a date/time formatter for the given skeleton and locale.
static DateFormat * | createInstanceForSkeleton (Calendar *calendarToAdopt, const UnicodeString &skeleton, const Locale &locale, UErrorCode &status)
| Creates a date/time formatter for the given skeleton and locale.
static const Locale * | getAvailableLocales (int32_t &count)
| Gets the set of locales for which DateFormats are installed.

## Friends
class | DateFormat
class | DateIntervalFormat

## Additional Inherited Members
Public Types inherited from icu::DateFormat
enum | EStyle { kNone = -1 , kFull = 0 , kLong = 1 , kMedium = 2 , kShort = 3 , kDateOffset = kShort + 1 , kDateTime = 8 , kDateTimeOffset = kDateTime + 1 , kRelative = (1 << 7) , kFullRelative = (kFull | kRelative) , kLongRelative = kLong | kRelative , kMediumRelative = kMedium | kRelative , kShortRelative = kShort | kRelative , kDefault = kMedium , FULL = kFull , LONG = kLong , MEDIUM = kMedium , SHORT = kShort , DEFAULT = kDefault , DATE_OFFSET = kDateOffset , NONE = kNone , DATE_TIME = kDateTime }
| Constants for various style patterns. More...
enum | EField { kEraField = UDAT_ERA_FIELD , kYearField = UDAT_YEAR_FIELD , kMonthField = UDAT_MONTH_FIELD , kDateField = UDAT_DATE_FIELD , kHourOfDay1Field = UDAT_HOUR_OF_DAY1_FIELD , kHourOfDay0Field = UDAT_HOUR_OF_DAY0_FIELD , kMinuteField = UDAT_MINUTE_FIELD , kSecondField = UDAT_SECOND_FIELD , kMillisecondField = UDAT_FRACTIONAL_SECOND_FIELD , kDayOfWeekField = UDAT_DAY_OF_WEEK_FIELD , kDayOfYearField = UDAT_DAY_OF_YEAR_FIELD , kDayOfWeekInMonthField = UDAT_DAY_OF_WEEK_IN_MONTH_FIELD , kWeekOfYearField = UDAT_WEEK_OF_YEAR_FIELD , kWeekOfMonthField = UDAT_WEEK_OF_MONTH_FIELD , kAmPmField = UDAT_AM_PM_FIELD , kHour1Field = UDAT_HOUR1_FIELD , kHour0Field = UDAT_HOUR0_FIELD , kTimezoneField = UDAT_TIMEZONE_FIELD , kYearWOYField = UDAT_YEAR_WOY_FIELD , kDOWLocalField = UDAT_DOW_LOCAL_FIELD , kExtendedYearField = UDAT_EXTENDED_YEAR_FIELD , kJulianDayField = UDAT_JULIAN_DAY_FIELD , kMillisecondsInDayField = UDAT_MILLISECONDS_IN_DAY_FIELD , ERA_FIELD = UDAT_ERA_FIELD , YEAR_FIELD = UDAT_YEAR_FIELD , MONTH_FIELD = UDAT_MONTH_FIELD , DATE_FIELD = UDAT_DATE_FIELD , HOUR_OF_DAY1_FIELD = UDAT_HOUR_OF_DAY1_FIELD , HOUR_OF_DAY0_FIELD = UDAT_HOUR_OF_DAY0_FIELD , MINUTE_FIELD = UDAT_MINUTE_FIELD , SECOND_FIELD = UDAT_SECOND_FIELD , MILLISECOND_FIELD = UDAT_FRACTIONAL_SECOND_FIELD , DAY_OF_WEEK_FIELD = UDAT_DAY_OF_WEEK_FIELD , DAY_OF_YEAR_FIELD = UDAT_DAY_OF_YEAR_FIELD , DAY_OF_WEEK_IN_MONTH_FIELD = UDAT_DAY_OF_WEEK_IN_MONTH_FIELD , WEEK_OF_YEAR_FIELD = UDAT_WEEK_OF_YEAR_FIELD , WEEK_OF_MONTH_FIELD = UDAT_WEEK_OF_MONTH_FIELD , AM_PM_FIELD = UDAT_AM_PM_FIELD , HOUR1_FIELD = UDAT_HOUR1_FIELD , HOUR0_FIELD = UDAT_HOUR0_FIELD , TIMEZONE_FIELD = UDAT_TIMEZONE_FIELD }
| Field selector for FieldPosition for DateFormat fields. More...
Protected Member Functions inherited from icu::DateFormat
| DateFormat ()
| Default constructor.
| DateFormat (const DateFormat &)
| Copy constructor.
DateFormat & | operator= (const DateFormat &)
| Default assignment operator.
Protected Member Functions inherited from icu::Format
void | setLocaleIDs (const char *valid, const char *actual)
| Format ()
| Default constructor for subclass use only.
| Format (const Format &)
Format & | operator= (const Format &)
Static Protected Member Functions inherited from icu::Format
static void | syntaxError (const UnicodeString &pattern, int32_t pos, UParseError &parseError)
| Simple function for initializing a UParseError from a UnicodeString.
Protected Attributes inherited from icu::DateFormat
Calendar * | fCalendar
| The calendar that DateFormat uses to produce the time field values needed to implement date/time formatting.
NumberFormat * | fNumberFormat
| The number formatter that DateFormat uses to format numbers in dates and times.

## Detailed Description

SimpleDateFormat is a concrete class for formatting and parsing dates in a language-independent manner.

It allows for formatting (millis -> text), parsing (text -> millis), and normalization. Formats/Parses a date or time, which is the standard milliseconds since 24:00 GMT, Jan 1, 1970.

Clients are encouraged to create a date-time formatter using DateFormat::getInstance(), getDateInstance(), getDateInstance(), or getDateTimeInstance() rather than explicitly constructing an instance of SimpleDateFormat. This way, the client is guaranteed to get an appropriate formatting pattern for whatever locale the program is running in. However, if the client needs something more unusual than the default patterns in the locales, he can construct a SimpleDateFormat directly and give it an appropriate pattern (or use one of the factory methods on DateFormat and modify the pattern after the fact with toPattern() and applyPattern().

Date and Time Patterns:

Date and time formats are specified by date and time pattern strings. Within date and time pattern strings, all unquoted ASCII letters [A-Za-z] are reserved as pattern letters representing calendar fields. `SimpleDateFormat` supports the date and time formatting algorithm and pattern letters defined by UTS#35 Unicode Locale Data Markup Language (LDML) and further documented for ICU in the ICU User Guide. The following pattern letters are currently available (note that the actual values depend on CLDR and may change from the examples shown here):

Field | Sym. | No. | Example | Description
--- | --- | --- | --- | ---
era | G | 1..3 | AD | Era - Replaced with the Era string for the current date. One to three letters for the abbreviated form, four letters for the long (wide) form, five for the narrow form.
4 | Anno Domini
5 | A
year | y | 1..n | 1996 | Year. Normally the length specifies the padding, but for two letters it also specifies the maximum length. Example:
Year | y | yy | yyy | yyyy | yyyyy
--- | --- | --- | --- | --- | ---
AD 1 | 1 | 01 | 001 | 0001 | 00001
AD 12 | 12 | 12 | 012 | 0012 | 00012
AD 123 | 123 | 23 | 123 | 0123 | 00123
AD 1234 | 1234 | 34 | 1234 | 1234 | 01234
AD 12345 | 12345 | 45 | 12345 | 12345 | 12345
Y | 1..n | 1997 | Year (in "Week of Year" based calendars). Normally the length specifies the padding, but for two letters it also specifies the maximum length. This year designation is used in ISO year-week calendar as defined by ISO 8601, but can be used in non-Gregorian based calendar systems where week date processing is desired. May not always be the same value as calendar year.
u | 1..n | 4601 | Extended year. This is a single number designating the year of this calendar system, encompassing all supra-year fields. For example, for the Julian calendar system, year numbers are positive, with an era of BCE or CE. An extended year value for the Julian calendar system assigns positive values to CE years and negative values to BCE years, with 1 BCE being year 0.
U | 1..3 | &#30002;&#23376; | Cyclic year name. Calendars such as the Chinese lunar calendar (and related calendars) and the Hindu calendars use 60-year cycles of year names. Use one through three letters for the abbreviated name, four for the full (wide) name, or five for the narrow name (currently the data only provides abbreviated names, which will be used for all requested name widths). If the calendar does not provide cyclic year name data, or if the year value to be formatted is out of the range of years for which cyclic name data is provided, then numeric formatting is used (behaves like 'y').
4 | (currently also &#30002;&#23376;)
5 | (currently also &#30002;&#23376;)
quarter | Q | 1..2 | 02 | Quarter - Use one or two for the numerical quarter, three for the abbreviation, or four for the full (wide) name (five for the narrow name is not yet supported).
3 | Q2
4 | 2nd quarter
q | 1..2 | 02 | Stand-Alone Quarter - Use one or two for the numerical quarter, three for the abbreviation, or four for the full name (five for the narrow name is not yet supported).
3 | Q2
4 | 2nd quarter
month | M | 1..2 | 09 | Month - Use one or two for the numerical month, three for the abbreviation, four for the full (wide) name, or five for the narrow name. With two ("MM"), the month number is zero-padded if necessary (e.g. "08")
3 | Sep
4 | September
5 | S
L | 1..2 | 09 | Stand-Alone Month - Use one or two for the numerical month, three for the abbreviation, four for the full (wide) name, or 5 for the narrow name. With two ("LL"), the month number is zero-padded if necessary (e.g. "08")
3 | Sep
4 | September
5 | S
week | w | 1..2 | 27 | Week of Year. Use "w" to show the minimum number of digits, or "ww" to always show two digits (zero-padding if necessary, e.g. "08").
W | 1 | 3 | Week of Month
day | d | 1..2 | 1 | Date - Day of the month. Use "d" to show the minimum number of digits, or "dd" to always show two digits (zero-padding if necessary, e.g. "08").
D | 1..3 | 345 | Day of year
F | 1 | 2 | Day of Week in Month. The example is for the 2nd Wed in July
g | 1..n | 2451334 | Modified Julian day. This is different from the conventional Julian day number in two regards. First, it demarcates days at local zone midnight, rather than noon GMT. Second, it is a local number; that is, it depends on the local time zone. It can be thought of as a single number that encompasses all the date-related fields.
week day | E | 1..3 | Tue | Day of week - Use one through three letters for the short day, four for the full (wide) name, five for the narrow name, or six for the short name.
4 | Tuesday
5 | T
6 | Tu
e | 1..2 | 2 | Local day of week. Same as E except adds a numeric value that will depend on the local starting day of the week, using one or two letters. For this example, Monday is the first day of the week.
3 | Tue
4 | Tuesday
5 | T
6 | Tu
c | 1 | 2 | Stand-Alone local day of week - Use one letter for the local numeric value (same as 'e'), three for the short day, four for the full (wide) name, five for the narrow name, or six for the short name.
3 | Tue
4 | Tuesday
5 | T
6 | Tu
period | a | 1 | AM | AM or PM
hour | h | 1..2 | 11 | Hour [1-12]. When used in skeleton data or in a skeleton passed in an API for flexible data pattern generation, it should match the 12-hour-cycle format preferred by the locale (h or K); it should not match a 24-hour-cycle format (H or k). Use hh for zero padding.
H | 1..2 | 13 | Hour [0-23]. When used in skeleton data or in a skeleton passed in an API for flexible data pattern generation, it should match the 24-hour-cycle format preferred by the locale (H or k); it should not match a 12-hour-cycle format (h or K). Use HH for zero padding.
K | 1..2 | 0 | Hour [0-11]. When used in a skeleton, only matches K or h, see above. Use KK for zero padding.
k | 1..2 | 24 | Hour [1-24]. When used in a skeleton, only matches k or H, see above. Use kk for zero padding.
minute | m | 1..2 | 59 | Minute. Use "m" to show the minimum number of digits, or "mm" to always show two digits (zero-padding if necessary, e.g. "08").
second | s | 1..2 | 12 | Second. Use "s" to show the minimum number of digits, or "ss" to always show two digits (zero-padding if necessary, e.g. "08").
S | 1..n | 3450 | Fractional Second - truncates (like other time fields) to the count of letters when formatting. Appends zeros if more than 3 letters specified. Truncates at three significant digits when parsing. (example shows display using pattern SSSS for seconds value 12.34567)
A | 1..n | 69540000 | Milliseconds in day. This field behaves exactly like a composite of all time-related fields, not including the zone fields. As such, it also reflects discontinuities of those fields on DST transition days. On a day of DST onset, it will jump forward. On a day of DST cessation, it will jump backward. This reflects the fact that is must be combined with the offset field to obtain a unique local time value.
zone | z | 1..3 | PDT | The short specific non-location format. Where that is unavailable, falls back to the short localized GMT format ("O").
4 | Pacific Daylight Time | The long specific non-location format. Where that is unavailable, falls back to the long localized GMT format ("OOOO").
Z | 1..3 | -0800 | The ISO8601 basic format with hours, minutes and optional seconds fields. The format is equivalent to RFC 822 zone format (when optional seconds field is absent). This is equivalent to the "xxxx" specifier.
4 | GMT-8:00 | The long localized GMT format. This is equivalent to the "OOOO" specifier.
5 | -08:00 -07:52:58 | The ISO8601 extended format with hours, minutes and optional seconds fields. The ISO8601 UTC indicator "Z" is used when local time offset is 0. This is equivalent to the "XXXXX" specifier.
O | 1 | GMT-8 | The short localized GMT format.
4 | GMT-08:00 | The long localized GMT format.
v | 1 | PT | The short generic non-location format. Where that is unavailable, falls back to the generic location format ("VVVV"), then the short localized GMT format as the final fallback.
4 | Pacific Time | The long generic non-location format. Where that is unavailable, falls back to generic location format ("VVVV").
V | 1 | uslax | The short time zone ID. Where that is unavailable, the special short time zone ID unk (Unknown Zone) is used. Note: This specifier was originally used for a variant of the short specific non-location format, but it was deprecated in the later version of the LDML specification. In CLDR 23/ICU 51, the definition of the specifier was changed to designate a short time zone ID.
2 | America/Los_Angeles | The long time zone ID.
3 | Los Angeles | The exemplar city (location) for the time zone. Where that is unavailable, the localized exemplar city name for the special zone Etc/Unknown is used as the fallback (for example, "Unknown City").
4 | Los Angeles Time | The generic location format. Where that is unavailable, falls back to the long localized GMT format ("OOOO"; Note: Fallback is only necessary with a GMT-style Time Zone ID, like Etc/GMT-830.) This is especially useful when presenting possible timezone choices for user selection, since the naming is more uniform than the "v" format.
X | 1 | -08 +0530 Z | The ISO8601 basic format with hours field and optional minutes field. The ISO8601 UTC indicator "Z" is used when local time offset is 0.
2 | -0800 Z | The ISO8601 basic format with hours and minutes fields. The ISO8601 UTC indicator "Z" is used when local time offset is 0.
3 | -08:00 Z | The ISO8601 extended format with hours and minutes fields. The ISO8601 UTC indicator "Z" is used when local time offset is 0.
4 | -0800 -075258 Z | The ISO8601 basic format with hours, minutes and optional seconds fields. (Note: The seconds field is not supported by the ISO8601 specification.) The ISO8601 UTC indicator "Z" is used when local time offset is 0.
5 | -08:00 -07:52:58 Z | The ISO8601 extended format with hours, minutes and optional seconds fields. (Note: The seconds field is not supported by the ISO8601 specification.) The ISO8601 UTC indicator "Z" is used when local time offset is 0.
x | 1 | -08 +0530 | The ISO8601 basic format with hours field and optional minutes field.
2 | -0800 | The ISO8601 basic format with hours and minutes fields.
3 | -08:00 | The ISO8601 extended format with hours and minutes fields.
4 | -0800 -075258 | The ISO8601 basic format with hours, minutes and optional seconds fields. (Note: The seconds field is not supported by the ISO8601 specification.)
5 | -08:00 -07:52:58 | The ISO8601 extended format with hours, minutes and optional seconds fields. (Note: The seconds field is not supported by the ISO8601 specification.)

Any characters in the pattern that are not in the ranges of ['a'..'z'] and ['A'..'Z'] will be treated as quoted text. For instance, characters like ':', '.', ' ', '#' and '@' will appear in the resulting time text even they are not embraced within single quotes.

A pattern containing any invalid pattern letter will result in a failing UErrorCode result during formatting or parsing.

Examples using the US locale:

    Format Pattern                         Result
    --------------                         -------
    "yyyy.MM.dd G 'at' HH:mm:ss vvvv" ->>  1996.07.10 AD at 15:08:56 Pacific Time
    "EEE, MMM d, ''yy"                ->>  Wed, July 10, '96
    "h:mm a"                          ->>  12:08 PM
    "hh 'o''clock' a, zzzz"           ->>  12 o'clock PM, Pacific Daylight Time
    "K:mm a, vvv"                     ->>  0:00 PM, PT
    "yyyyy.MMMMM.dd GGG hh:mm aaa"    ->>  1996.July.10 AD 12:08 PM
    icu::FormatBase class for all formats.Definition format.h:98

Code Sample:

    UErrorCode success = U_ZERO_ERROR;
    SimpleTimeZone* pdt = new SimpleTimeZone(-8 * 60 * 60 * 1000, "PST");
    pdt->setStartRule( Calendar::APRIL, 1, Calendar::SUNDAY, 2*60*60*1000);
    pdt->setEndRule( Calendar::OCTOBER, -1, Calendar::SUNDAY, 2*60*60*1000);

    // Format the current time.
    SimpleDateFormat* formatter
        = new SimpleDateFormat ("yyyy.MM.dd G 'at' hh:mm:ss a zzz", success );
    GregorianCalendar cal(success);
    UDate currentTime_1 = cal.getTime(success);
    FieldPosition fp(FieldPosition::DONT_CARE);
    UnicodeString dateString;
    formatter->format( currentTime_1, dateString, fp );
    cout << "result: " << dateString << endl;

    // Parse the previous string back into a Date.
    ParsePosition pp(0);
    UDate currentTime_2 = formatter->parse(dateString, pp );
    icu::FieldPositionFieldPosition is a simple class used by Format and its subclasses to identify fields in formatted out...Definition fieldpos.h:110
    icu::GregorianCalendarConcrete class which provides the standard calendar used by most of the world.Definition gregocal.h:153
    icu::ParsePositionParsePosition is a simple class used by Format and its subclasses to keep track of the current positi...Definition parsepos.h:52
    icu::SimpleDateFormatSimpleDateFormat is a concrete class for formatting and parsing dates in a language-independent manne...Definition smpdtfmt.h:727
    icu::SimpleDateFormat::parsevirtual void parse(const UnicodeString &text, Calendar &cal, ParsePosition &pos) const overrideParse a date/time string beginning at the given parse position.
    icu::SimpleDateFormat::formatvirtual UnicodeString & format(Calendar &cal, UnicodeString &appendTo, FieldPosition &pos) const overrideFormat a date or time, which is the standard millis since 24:00 GMT, Jan 1, 1970.
    icu::SimpleTimeZoneSimpleTimeZone is a concrete subclass of TimeZone that represents a time zone for use with a Gregoria...Definition simpletz.h:65
    icu::SimpleTimeZone::setEndRulevoid setEndRule(int32_t month, int32_t dayOfWeekInMonth, int32_t dayOfWeek, int32_t time, UErrorCode &status)Sets the daylight savings ending rule.Definition simpletz.h:912
    icu::SimpleTimeZone::setStartRulevoid setStartRule(int32_t month, int32_t dayOfWeekInMonth, int32_t dayOfWeek, int32_t time, UErrorCode &status)Sets the daylight savings starting rule.Definition simpletz.h:894
    icu::UnicodeStringUnicodeString is a string class that stores Unicode characters directly and provides similar function...Definition unistr.h:296
    UErrorCodeUErrorCodeStandard ICU4C error code type, a substitute for exceptions.Definition utypes.h:415
    U_ZERO_ERROR@ U_ZERO_ERRORNo error, no warning.Definition utypes.h:449
    UDatedouble UDateDate and Time data type.Definition utypes.h:203

In the above example, the time value "currentTime_2" obtained from parsing will be equal to currentTime_1. However, they may not be equal if the am/pm marker 'a' is left out from the format pattern while the "hour in am/pm" pattern symbol is used. This information loss can happen when formatting the time in PM.

When parsing a date string using the abbreviated year pattern ("y" or "yy"), SimpleDateFormat must interpret the abbreviated year relative to some century. It does this by adjusting dates to be within 80 years before and 20 years after the time the SimpleDateFormat instance is created. For example, using a pattern of "MM/dd/yy" and a SimpleDateFormat instance created on Jan 1, 1997, the string "01/11/12" would be interpreted as Jan 11, 2012 while the string "05/04/64" would be interpreted as May 4, 1964. During parsing, only strings consisting of exactly two digits, as defined by `Unicode::isDigit()`, will be parsed into the default century. Any other numeric string, such as a one digit string, a three or more digit string, or a two digit string that isn't all digits (for example, "-1"), is interpreted literally. So "01/02/3" or "01/02/003" are parsed (for the Gregorian calendar), using the same pattern, as Jan 2, 3 AD. Likewise (but only in lenient parse mode, the default) "01/02/-3" is parsed as Jan 2, 4 BC.

If the year pattern has more than two 'y' characters, the year is interpreted literally, regardless of the number of digits. So using the pattern "MM/dd/yyyy", "01/11/12" parses to Jan 11, 12 A.D.

When numeric fields abut one another directly, with no intervening delimiter characters, they constitute a run of abutting numeric fields. Such runs are parsed specially. For example, the format "HHmmss" parses the input text "123456" to 12:34:56, parses the input text "12345" to 1:23:45, and fails to parse "1234". In other words, the leftmost field of the run is flexible, while the others keep a fixed width. If the parse fails anywhere in the run, then the leftmost field is shortened by one character, and the entire run is parsed again. This is repeated until either the parse succeeds or the leftmost field is one character in length. If the parse still fails at that point, the parse of the run fails.

For time zones that have no names, SimpleDateFormat uses strings GMT+hours:minutes or GMT-hours:minutes.

The calendar defines what is the first day of the week, the first week of the year, whether hours are zero based or not (0 vs 12 or 24), and the timezone. There is one common number format to handle all the numbers; the digit count is handled programmatically according to the pattern.

User subclasses are not supported. While clients may write subclasses, such code will not necessarily work and will not be guaranteed to work stably from release to release.

Definition at line 727 of file smpdtfmt.h.

## Constructor & Destructor Documentation

## ◆ SimpleDateFormat() [1/8]

icu::SimpleDateFormat::SimpleDateFormat | ( | UErrorCode & | status | ) |

Construct a SimpleDateFormat using the default pattern for the default locale.

[Note:] Not all locales support SimpleDateFormat; for full generality, use the factory methods in the DateFormat class.

Parameters

  status | Output param set to success/failure code.

Stable:
  ICU 2.0

## ◆ SimpleDateFormat() [2/8]

icu::SimpleDateFormat::SimpleDateFormat | ( | const UnicodeString & | pattern,
|  | UErrorCode & | status
| ) |  |

Construct a SimpleDateFormat using the given pattern and the default locale.

The locale is used to obtain the symbols used in formatting (e.g., the names of the months), but not to provide the pattern.

[Note:] Not all locales support SimpleDateFormat; for full generality, use the factory methods in the DateFormat class.

Parameters

  pattern | the pattern for the format.
  status | Output param set to success/failure code.

Stable:
  ICU 2.0

## ◆ SimpleDateFormat() [3/8]

icu::SimpleDateFormat::SimpleDateFormat | ( | const UnicodeString & | pattern,
|  | const UnicodeString & | override,
|  | UErrorCode & | status
| ) |  |

Construct a SimpleDateFormat using the given pattern, numbering system override, and the default locale.

The locale is used to obtain the symbols used in formatting (e.g., the names of the months), but not to provide the pattern.

A numbering system override is a string containing either the name of a known numbering system, or a set of field and numbering system pairs that specify which fields are to be formatted with the alternate numbering system. For example, to specify that all numeric fields in the specified date or time pattern are to be rendered using Thai digits, simply specify the numbering system override as "thai". To specify that just the year portion of the date be formatted using Hebrew numbering, use the override string "y=hebrew". Numbering system overrides can be combined using a semi-colon character in the override string, such as "d=decimal;M=arabic;y=hebrew", etc.

[Note:] Not all locales support SimpleDateFormat; for full generality, use the factory methods in the DateFormat class.

Parameters

  pattern | the pattern for the format.
  override | the override string.
  status | Output param set to success/failure code.

Stable:
  ICU 4.2

## ◆ SimpleDateFormat() [4/8]

icu::SimpleDateFormat::SimpleDateFormat | ( | const UnicodeString & | pattern,
|  | const Locale & | locale,
|  | UErrorCode & | status
| ) |  |

Construct a SimpleDateFormat using the given pattern and locale.

The locale is used to obtain the symbols used in formatting (e.g., the names of the months), but not to provide the pattern.

[Note:] Not all locales support SimpleDateFormat; for full generality, use the factory methods in the DateFormat class.

Parameters

  pattern | the pattern for the format.
  locale | the given locale.
  status | Output param set to success/failure code.

Stable:
  ICU 2.0

## ◆ SimpleDateFormat() [5/8]

icu::SimpleDateFormat::SimpleDateFormat | ( | const UnicodeString & | pattern,
|  | const UnicodeString & | override,
|  | const Locale & | locale,
|  | UErrorCode & | status
| ) |  |

Construct a SimpleDateFormat using the given pattern, numbering system override, and locale.

The locale is used to obtain the symbols used in formatting (e.g., the names of the months), but not to provide the pattern.

A numbering system override is a string containing either the name of a known numbering system, or a set of field and numbering system pairs that specify which fields are to be formatted with the alternate numbering system. For example, to specify that all numeric fields in the specified date or time pattern are to be rendered using Thai digits, simply specify the numbering system override as "thai". To specify that just the year portion of the date be formatted using Hebrew numbering, use the override string "y=hebrew". Numbering system overrides can be combined using a semi-colon character in the override string, such as "d=decimal;M=arabic;y=hebrew", etc.

[Note:] Not all locales support SimpleDateFormat; for full generality, use the factory methods in the DateFormat class.

Parameters

  pattern | the pattern for the format.
  override | the numbering system override.
  locale | the given locale.
  status | Output param set to success/failure code.

Stable:
  ICU 4.2

## ◆ SimpleDateFormat() [6/8]

icu::SimpleDateFormat::SimpleDateFormat | ( | const UnicodeString & | pattern,
|  | DateFormatSymbols * | formatDataToAdopt,
|  | UErrorCode & | status
| ) |  |

Construct a SimpleDateFormat using the given pattern and locale-specific symbol data.

The formatter takes ownership of the DateFormatSymbols object; the caller is no longer responsible for deleting it.

Parameters

  pattern | the given pattern for the format.
  formatDataToAdopt | the symbols to be adopted.
  status | Output param set to success/faulure code.

Stable:
  ICU 2.0

## ◆ SimpleDateFormat() [7/8]

icu::SimpleDateFormat::SimpleDateFormat | ( | const UnicodeString & | pattern,
|  | const DateFormatSymbols & | formatData,
|  | UErrorCode & | status
| ) |  |

Construct a SimpleDateFormat using the given pattern and locale-specific symbol data.

The DateFormatSymbols object is NOT adopted; the caller remains responsible for deleting it.

Parameters

  pattern | the given pattern for the format.
  formatData | the formatting symbols to be use.
  status | Output param set to success/faulure code.

Stable:
  ICU 2.0

## ◆ SimpleDateFormat() [8/8]

icu::SimpleDateFormat::SimpleDateFormat | ( | const SimpleDateFormat & |  | ) |

Copy constructor.

Stable:
  ICU 2.0

## ◆ ~SimpleDateFormat()

virtual icu::SimpleDateFormat::~SimpleDateFormat | ( |  | ) |
| virtual

Destructor.

Stable:
  ICU 2.0

## Member Function Documentation

## ◆ adoptCalendar()

virtual void icu::SimpleDateFormat::adoptCalendar | ( | Calendar * | calendarToAdopt | ) |
| overridevirtual

Set the calendar to be used by this date format.

Initially, the default calendar for the specified or default locale is used. The caller should not delete the Calendar object after it is adopted by this call. Adopting a new calendar will change to the default symbols.

Parameters

  calendarToAdopt | Calendar object to be adopted.

Stable:
  ICU 2.0

Reimplemented from icu::DateFormat.

## ◆ adoptDateFormatSymbols()

virtual void icu::SimpleDateFormat::adoptDateFormatSymbols | ( | DateFormatSymbols * | newFormatSymbols | ) |
| virtual

Set the date/time formatting symbols.

The caller no longer owns the DateFormatSymbols object and should not delete it after making this call.

Parameters

  newFormatSymbols | the given date-time formatting symbols to copy.

Stable:
  ICU 2.0

## ◆ adoptNumberFormat() [1/2]

void icu::SimpleDateFormat::adoptNumberFormat | ( | const UnicodeString & | fields,
|  | NumberFormat * | formatToAdopt,
|  | UErrorCode & | status
| ) |  |

Allow the user to set the NumberFormat for several fields It can be a single field like: "y"(year) or "M"(month) It can be several field combined together: "yM"(year and month) Note: 1 symbol field is enough for multiple symbol field (so "y" will override "yy", "yyy") If the field is not numeric, then override has no effect (like "MMM" will use abbreviation, not numerical field) Per field NumberFormat can also be cleared in {.

See also
  DateFormat::setNumberFormat(const NumberFormat& newNumberFormat)}

Parameters

  fields | the fields to override(like y)
  formatToAdopt | the NumbeferFormat used
  status | Receives a status code, which will be U_ZERO_ERROR if the operation succeeds.

Stable:
  ICU 54

## ◆ adoptNumberFormat() [2/2]

void icu::SimpleDateFormat::adoptNumberFormat | ( | NumberFormat * | formatToAdopt | ) |
| overridevirtual

Overrides base class method and This method clears per field NumberFormat instances previously set by {.

See also
  adoptNumberFormat(const UnicodeString&, NumberFormat*, UErrorCode)}

Parameters

  formatToAdopt | the NumbeferFormat used

Stable:
  ICU 54

Reimplemented from icu::DateFormat.

## ◆ adoptTimeZoneFormat()

virtual void icu::SimpleDateFormat::adoptTimeZoneFormat | ( | TimeZoneFormat * | timeZoneFormatToAdopt | ) |
| virtual

Sets the TimeZoneFormat to be used by this date/time formatter.

The caller should not delete the TimeZoneFormat object after it is adopted by this call.

Parameters

  timeZoneFormatToAdopt | The TimeZoneFormat object to be adopted.

Internal:
  Do not use. This API is for internal use only. ICU 49 technology preview

## ◆ applyLocalizedPattern()

virtual void icu::SimpleDateFormat::applyLocalizedPattern | ( | const UnicodeString & | pattern,
|  | UErrorCode & | status
| ) |  |
| virtual

Apply the given localized pattern string to this date format.

(see toLocalizedPattern() for more information on localized patterns.)

Parameters

  pattern | The localized pattern to be applied.
  status | Output param set to success/failure code on exit. If the pattern is invalid, this will be set to a failure result.

Stable:
  ICU 2.0

## ◆ applyPattern()

virtual void icu::SimpleDateFormat::applyPattern | ( | const UnicodeString & | pattern | ) |
| virtual

Apply the given unlocalized pattern string to this date format.

(i.e., after this call, this formatter will format dates according to the new pattern)

Parameters

  pattern | The pattern to be applied.

Stable:
  ICU 2.0

## ◆ clone()

virtual SimpleDateFormat * icu::SimpleDateFormat::clone | ( |  | ) | const
| overridevirtual

Clone this Format object polymorphically.

The caller owns the result and should delete it when done.

Returns
  A copy of the object.

Stable:
  ICU 2.0

Implements icu::DateFormat.

## ◆ format() [1/12]

virtual UnicodeString & icu::DateFormat::format | ( | Calendar & | cal,
|  | UnicodeString & | appendTo,
|  | FieldPosition & | fieldPosition
| ) |  | const
| virtual

Formats a date into a date/time string.

This is an abstract method which concrete subclasses must implement.

On input, the FieldPosition parameter may have its "field" member filled with an enum value specifying a field. On output, the FieldPosition will be filled in with the text offsets for that field.

For example, given a time text "1996.07.10 AD at 15:08:56 PDT", if the given fieldPosition.field is UDAT_YEAR_FIELD, the offsets fieldPosition.beginIndex and statfieldPositionus.getEndIndex will be set to 0 and 4, respectively.

Notice that if the same time field appears more than once in a pattern, the status will be set for the first occurrence of that time field. For instance, formatting a UDate to the time string "1 PM PDT (Pacific Daylight Time)" using the pattern "h a z (zzzz)" and the alignment field DateFormat::TIMEZONE_FIELD, the offsets fieldPosition.beginIndex and fieldPosition.getEndIndex will be set to 5 and 8, respectively, for the first occurrence of the timezone pattern character 'z'.

Parameters

  cal | Calendar set to the date and time to be formatted into a date/time string. When the calendar type is different from the internal calendar held by this DateFormat instance, the date and the time zone will be inherited from the input calendar, but other calendar field values will be calculated by the internal calendar.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  fieldPosition | On input: an alignment field, if desired (see examples above) On output: the offsets of the alignment field (see examples above)

Returns
  Reference to 'appendTo' parameter.

Stable:
  ICU 2.1

Implements icu::DateFormat.

## ◆ format() [2/12]

virtual UnicodeString & icu::SimpleDateFormat::format | ( | Calendar & | cal,
|  | UnicodeString & | appendTo,
|  | FieldPosition & | pos
| ) |  | const
| overridevirtual

Format a date or time, which is the standard millis since 24:00 GMT, Jan 1, 1970.

Overrides DateFormat pure virtual method.

Example: using the US locale: "yyyy.MM.dd e 'at' HH:mm:ss zzz" ->> 1996.07.10 AD at 15:08:56 PDT

Parameters

  cal | Calendar set to the date and time to be formatted into a date/time string.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  pos | The formatting position. On input: an alignment field, if desired. On output: the offsets of the alignment field.

Returns
  Reference to 'appendTo' parameter.

Stable:
  ICU 2.1

Implements icu::DateFormat.

## ◆ format() [3/12]

virtual UnicodeString & icu::DateFormat::format | ( | Calendar & | cal,
|  | UnicodeString & | appendTo,
|  | FieldPositionIterator * | posIter,
|  | UErrorCode & | status
| ) |  | const
| virtual

Formats a date into a date/time string.

Subclasses should implement this method.

Parameters

  cal | Calendar set to the date and time to be formatted into a date/time string. When the calendar type is different from the internal calendar held by this DateFormat instance, the date and the time zone will be inherited from the input calendar, but other calendar field values will be calculated by the internal calendar.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  posIter | On return, can be used to iterate over positions of fields generated by this format call. Field values are defined in UDateFormatField. Can be nullptr.
  status | error status.

Returns
  Reference to 'appendTo' parameter.

Stable:
  ICU 4.4

Reimplemented from icu::DateFormat.

## ◆ format() [4/12]

virtual UnicodeString & icu::SimpleDateFormat::format | ( | Calendar & | cal,
|  | UnicodeString & | appendTo,
|  | FieldPositionIterator * | posIter,
|  | UErrorCode & | status
| ) |  | const
| overridevirtual

Format a date or time, which is the standard millis since 24:00 GMT, Jan 1, 1970.

Overrides DateFormat pure virtual method.

Example: using the US locale: "yyyy.MM.dd e 'at' HH:mm:ss zzz" ->> 1996.07.10 AD at 15:08:56 PDT

Parameters

  cal | Calendar set to the date and time to be formatted into a date/time string.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  posIter | On return, can be used to iterate over positions of fields generated by this format call. Field values are defined in UDateFormatField.
  status | Input/output param set to success/failure code.

Returns
  Reference to 'appendTo' parameter.

Stable:
  ICU 4.4

Reimplemented from icu::DateFormat.

## ◆ format() [5/12]

virtual UnicodeString & icu::Format::format | ( | const Formattable & | obj,
|  | UnicodeString & | appendTo,
|  | FieldPosition & | pos,
|  | UErrorCode & | status
| ) |  | const
| virtual

Format an object to produce a string.

This is a pure virtual method which subclasses must implement. This method allows polymorphic formatting of Formattable objects. If a subclass of Format receives a Formattable object type it doesn't handle (e.g., if a numeric Formattable is passed to a DateFormat object) then it returns a failing UErrorCode.

Parameters

  obj | The object to format.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  pos | On input: an alignment field, if desired. On output: the offsets of the alignment field.
  status | Output param filled with success/failure status.

Returns
  Reference to 'appendTo' parameter.

Stable:
  ICU 2.0

Reimplemented from icu::DateFormat.

## ◆ format() [6/12]

virtual UnicodeString & icu::DateFormat::format | ( | const Formattable & | obj,
|  | UnicodeString & | appendTo,
|  | FieldPosition & | pos,
|  | UErrorCode & | status
| ) |  | const
| overridevirtual

Format an object to produce a string.

This method handles Formattable objects with a UDate type. If a the Formattable object type is not a Date, then it returns a failing UErrorCode.

Parameters

  obj | The object to format. Must be a Date.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  pos | On input: an alignment field, if desired. On output: the offsets of the alignment field.
  status | Output param filled with success/failure status.

Returns
  Reference to 'appendTo' parameter.

Stable:
  ICU 2.0

Reimplemented from icu::DateFormat.

## ◆ format() [7/12]

virtual UnicodeString & icu::Format::format | ( | const Formattable & | obj,
|  | UnicodeString & | appendTo,
|  | FieldPositionIterator * | posIter,
|  | UErrorCode & | status
| ) |  | const
| virtual

Format an object to produce a string.

Subclasses should override this method. This method allows polymorphic formatting of Formattable objects. If a subclass of Format receives a Formattable object type it doesn't handle (e.g., if a numeric Formattable is passed to a DateFormat object) then it returns a failing UErrorCode.

Parameters

  obj | The object to format.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  posIter | On return, can be used to iterate over positions of fields generated by this format call.
  status | Output param filled with success/failure status.

Returns
  Reference to 'appendTo' parameter.

Stable:
  ICU 4.4

Reimplemented from icu::DateFormat.

## ◆ format() [8/12]

virtual UnicodeString & icu::DateFormat::format | ( | const Formattable & | obj,
|  | UnicodeString & | appendTo,
|  | FieldPositionIterator * | posIter,
|  | UErrorCode & | status
| ) |  | const
| overridevirtual

Format an object to produce a string.

This method handles Formattable objects with a UDate type. If a the Formattable object type is not a Date, then it returns a failing UErrorCode.

Parameters

  obj | The object to format. Must be a Date.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  posIter | On return, can be used to iterate over positions of fields generated by this format call. Field values are defined in UDateFormatField. Can be nullptr.
  status | Output param filled with success/failure status.

Returns
  Reference to 'appendTo' parameter.

Stable:
  ICU 4.4

Reimplemented from icu::DateFormat.

## ◆ format() [9/12]

UnicodeString & icu::Format::format | ( | const Formattable & | obj,
|  | UnicodeString & | appendTo,
|  | UErrorCode & | status
| ) |  | const

Formats an object to produce a string.

Parameters

  obj | The object to format.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  status | Output parameter filled in with success or failure status.

Returns
  Reference to 'appendTo' parameter.

Stable:
  ICU 2.0

## ◆ format() [10/12]

UnicodeString & icu::DateFormat::format | ( | UDate | date,
|  | UnicodeString & | appendTo
| ) |  | const

Formats a UDate into a date/time string.

If there is a problem, you won't know, using this method. Use the overloaded format() method which takes a FieldPosition& to detect formatting problems.

Parameters

  date | The UDate value to be formatted into a string.
  appendTo | Output parameter to receive result. Result is appended to existing contents.

Returns
  Reference to 'appendTo' parameter.

Stable:
  ICU 2.0

## ◆ format() [11/12]

UnicodeString & icu::DateFormat::format | ( | UDate | date,
|  | UnicodeString & | appendTo,
|  | FieldPosition & | fieldPosition
| ) |  | const

Formats a UDate into a date/time string.

On input, the FieldPosition parameter may have its "field" member filled with an enum value specifying a field. On output, the FieldPosition will be filled in with the text offsets for that field.

For example, given a time text "1996.07.10 AD at 15:08:56 PDT", if the given fieldPosition.field is UDAT_YEAR_FIELD, the offsets fieldPosition.beginIndex and statfieldPositionus.getEndIndex will be set to 0 and 4, respectively.

Notice that if the same time field appears more than once in a pattern, the status will be set for the first occurrence of that time field. For instance, formatting a UDate to the time string "1 PM PDT (Pacific Daylight Time)" using the pattern "h a z (zzzz)" and the alignment field DateFormat::TIMEZONE_FIELD, the offsets fieldPosition.beginIndex and fieldPosition.getEndIndex will be set to 5 and 8, respectively, for the first occurrence of the timezone pattern character 'z'.

Parameters

  date | UDate to be formatted into a date/time string.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  fieldPosition | On input: an alignment field, if desired (see examples above) On output: the offsets of the alignment field (see examples above)

Returns
  Reference to 'appendTo' parameter.

Stable:
  ICU 2.0

## ◆ format() [12/12]

UnicodeString & icu::DateFormat::format | ( | UDate | date,
|  | UnicodeString & | appendTo,
|  | FieldPositionIterator * | posIter,
|  | UErrorCode & | status
| ) |  | const

Formats a UDate into a date/time string.

Parameters

  date | UDate to be formatted into a date/time string.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  posIter | On return, can be used to iterate over positions of fields generated by this format call. Field values are defined in UDateFormatField. Can be nullptr.
  status | error status.

Returns
  Reference to 'appendTo' parameter.

Stable:
  ICU 4.4

## ◆ get2DigitYearStart()

UDate icu::SimpleDateFormat::get2DigitYearStart | ( | UErrorCode & | status | ) | const
| inline

Get the start UDate used to interpret two-digit year strings.

When dates are parsed having 2-digit year strings, they are placed within a assumed range of 100 years starting on the two digit start date. For example, the string "24-Jan-17" may be in the year 1817, 1917, 2017, or some other year. SimpleDateFormat chooses a year so that the resultant date is on or after the two digit start date and within 100 years of the two digit start date.

By default, the two digit start date is set to 80 years before the current time at which a SimpleDateFormat object is created.

Parameters

  status | Filled in with U_ZERO_ERROR if the parse was successful, and with an error value if there was a parse error.

Stable:
  ICU 2.0

Definition at line 1660 of file smpdtfmt.h.

## ◆ getDateFormatSymbols()

virtual const DateFormatSymbols * icu::SimpleDateFormat::getDateFormatSymbols | ( | void |  | ) | const
| virtual

Gets the date/time formatting symbols (this is an object carrying the various strings and other symbols used in formatting: e.g., month names and abbreviations, time zone names, AM/PM strings, etc.)

Returns
  a copy of the date-time formatting data associated with this date-time formatter.

Stable:
  ICU 2.0

## ◆ getDynamicClassID()

virtual UClassID icu::SimpleDateFormat::getDynamicClassID | ( | void |  | ) | const
| overridevirtual

Returns a unique class ID POLYMORPHICALLY.

Pure virtual override. This method is to implement a simple version of RTTI, since not all C++ compilers support genuine RTTI. Polymorphic operator==() and clone() methods call this method.

Returns
  The class ID for this object. All objects of a given class have the same class ID. Objects of other classes have different class IDs.

Stable:
  ICU 2.0

Reimplemented from icu::UObject.

## ◆ getNumberFormatForField()

const NumberFormat * icu::SimpleDateFormat::getNumberFormatForField | ( | char16_t | field | ) | const

Get the numbering system to be used for a particular field.

Parameters

  field | The UDateFormatField to get

Stable:
  ICU 54

## ◆ getSmpFmtLocale()

const Locale & icu::SimpleDateFormat::getSmpFmtLocale | ( | void |  | ) | const

This is for ICU internal use only.

Please do not use. Get the locale of this simple date formatter. It is used in DateIntervalFormat.

Returns
  locale in this simple date formatter

Internal:
  Do not use. This API is for internal use only. ICU 4.0

## ◆ getStaticClassID()

static UClassID icu::SimpleDateFormat::getStaticClassID | ( | void |  | ) |
| static

Return the class ID for this class.

This is useful only for comparing to a return value from getDynamicClassID(). For example:

    .   Base* polymorphic_pointer = createPolymorphicObject();
    .   if (polymorphic_pointer->getDynamicClassID() ==
    .       erived::getStaticClassID()) ...

Returns
  The class ID for all objects of this class.

Stable:
  ICU 2.0

## ◆ getTimeZoneFormat()

virtual const TimeZoneFormat * icu::SimpleDateFormat::getTimeZoneFormat | ( | void |  | ) | const
| virtual

Gets the time zone format object associated with this date/time formatter.

Returns
  the time zone format associated with this date/time formatter.

Internal:
  Do not use. This API is for internal use only. ICU 49 technology preview

## ◆ isFieldUnitIgnored() [1/2]

static UBool icu::SimpleDateFormat::isFieldUnitIgnored | ( | const UnicodeString & | pattern,
|  | UCalendarDateFields | field
| ) |  |
| static

This is for ICU internal use only.

Please do not use. Check whether the 'field' is smaller than all the fields covered in pattern, return true if it is. The sequence of calendar field, from large to small is: ERA, YEAR, MONTH, DATE, AM_PM, HOUR, MINUTE,...

Parameters

  pattern | the pattern to check against
  field | the calendar field need to check against

Returns
  true if the 'field' is smaller than all the fields covered in pattern. false otherwise.

Internal:
  Do not use. This API is for internal use only. ICU 4.0

## ◆ isFieldUnitIgnored() [2/2]

UBool icu::SimpleDateFormat::isFieldUnitIgnored | ( | UCalendarDateFields | field | ) | const

This is for ICU internal use only.

Please do not use. Check whether the 'field' is smaller than all the fields covered in pattern, return true if it is. The sequence of calendar field, from large to small is: ERA, YEAR, MONTH, DATE, AM_PM, HOUR, MINUTE,...

Parameters

  field | the calendar field need to check against

Returns
  true if the 'field' is smaller than all the fields covered in pattern. false otherwise.

Internal:
  Do not use. This API is for internal use only. ICU 4.0

## ◆ operator=()

SimpleDateFormat & icu::SimpleDateFormat::operator= | ( | const SimpleDateFormat & |  | ) |

Assignment operator.

Stable:
  ICU 2.0

## ◆ operator==()

virtual bool icu::SimpleDateFormat::operator== | ( | const Format & | other | ) | const
| overridevirtual

Return true if the given Format objects are semantically equal.

Objects of different subclasses are considered unequal.

Parameters

  other | the object to be compared with.

Returns
  true if the given Format objects are semantically equal.

Stable:
  ICU 2.0

Reimplemented from icu::DateFormat.

## ◆ parse() [1/4]

virtual void icu::SimpleDateFormat::parse | ( | const UnicodeString & | text,
|  | Calendar & | cal,
|  | ParsePosition & | pos
| ) |  | const
| overridevirtual

Parse a date/time string beginning at the given parse position.

For example, a time text "07/10/96 4:5 PM, PDT" will be parsed into a Date that is equivalent to Date(837039928046).

By default, parsing is lenient: If the input is not in the form used by this object's format method but can still be parsed as a date, then the parse succeeds. Clients may insist on strict adherence to the format by calling setLenient(false).

See also
  DateFormat::setLenient(boolean)

Parameters

  text | The date/time string to be parsed
  cal | A Calendar set on input to the date and time to be used for missing values in the date/time string being parsed, and set on output to the parsed date/time. When the calendar type is different from the internal calendar held by this SimpleDateFormat instance, the internal calendar will be cloned to a work calendar set to the same milliseconds and time zone as the cal parameter, field values will be parsed based on the work calendar, then the result (milliseconds and time zone) will be set in this calendar.
  pos | On input, the position at which to start parsing; on output, the position at which parsing terminated, or the start position if the parse failed.

Stable:
  ICU 2.1

Implements icu::DateFormat.

## ◆ parse() [2/4]

virtual void icu::DateFormat::parse | ( | const UnicodeString & | text,
|  | Calendar & | cal,
|  | ParsePosition & | pos
| ) |  | const
| virtual

Parse a date/time string beginning at the given parse position.

For example, a time text "07/10/96 4:5 PM, PDT" will be parsed into a Date that is equivalent to Date(837039928046).

By default, parsing is lenient: If the input is not in the form used by this object's format method but can still be parsed as a date, then the parse succeeds. Clients may insist on strict adherence to the format by calling setLenient(false).

See also
  DateFormat::setLenient(boolean)

Parameters

  text | The date/time string to be parsed.
  cal | A Calendar set on input to the date and time to be used for missing values in the date/time string being parsed, and set on output to the parsed date/time. When the calendar type is different from the internal calendar held by this DateFormat instance, the internal calendar will be cloned to a work calendar set to the same milliseconds and time zone as the cal parameter, field values will be parsed based on the work calendar, then the result (milliseconds and time zone) will be set in this calendar.
  pos | On input, the position at which to start parsing; on output, the position at which parsing terminated, or the start position if the parse failed.

Stable:
  ICU 2.1

Implements icu::DateFormat.

## ◆ parse() [3/4]

UDate icu::DateFormat::parse | ( | const UnicodeString & | text,
|  | ParsePosition & | pos
| ) |  | const

Parse a date/time string beginning at the given parse position.

For example, a time text "07/10/96 4:5 PM, PDT" will be parsed into a Date that is equivalent to Date(837039928046).

By default, parsing is lenient: If the input is not in the form used by this object's format method but can still be parsed as a date, then the parse succeeds. Clients may insist on strict adherence to the format by calling setLenient(false).

See also
  DateFormat::setLenient(boolean)

Note that the normal date formats associated with some calendars - such as the Chinese lunar calendar - do not specify enough fields to enable dates to be parsed unambiguously. In the case of the Chinese lunar calendar, while the year within the current 60-year cycle is specified, the number of such cycles since the start date of the calendar (in the ERA field of the Calendar object) is not normally part of the format, and parsing may assume the wrong era. For cases such as this it is recommended that clients parse using the method parse(const UnicodeString&, Calendar& cal, ParsePosition&) with the Calendar passed in set to the current date, or to a date within the era/cycle that should be assumed if absent in the format.

Parameters

  text | The date/time string to be parsed into a UDate value.
  pos | On input, the position at which to start parsing; on output, the position at which parsing terminated, or the start position if the parse failed.

Returns
  A valid UDate if the input could be parsed.

Stable:
  ICU 2.0

## ◆ parse() [4/4]

virtual UDate icu::DateFormat::parse | ( | const UnicodeString & | text,
|  | UErrorCode & | status
| ) |  | const
| virtual

Parse a date/time string.

For example, a time text "07/10/96 4:5 PM, PDT" will be parsed into a UDate that is equivalent to Date(837039928046). Parsing begins at the beginning of the string and proceeds as far as possible. Assuming no parse errors were encountered, this function doesn't return any information about how much of the string was consumed by the parsing. If you need that information, use the version of parse() that takes a ParsePosition.

By default, parsing is lenient: If the input is not in the form used by this object's format method but can still be parsed as a date, then the parse succeeds. Clients may insist on strict adherence to the format by calling setLenient(false).

See also
  DateFormat::setLenient(boolean)

Note that the normal date formats associated with some calendars - such as the Chinese lunar calendar - do not specify enough fields to enable dates to be parsed unambiguously. In the case of the Chinese lunar calendar, while the year within the current 60-year cycle is specified, the number of such cycles since the start date of the calendar (in the ERA field of the Calendar object) is not normally part of the format, and parsing may assume the wrong era. For cases such as this it is recommended that clients parse using the method parse(const UnicodeString&, Calendar& cal, ParsePosition&) with the Calendar passed in set to the current date, or to a date within the era/cycle that should be assumed if absent in the format.

Parameters

  text | The date/time string to be parsed into a UDate value.
  status | Output param to be set to success/failure code. If 'text' cannot be parsed, it will be set to a failure code.

Returns
  The parsed UDate value, if successful.

Stable:
  ICU 2.0

Reimplemented from icu::DateFormat.

## ◆ set2DigitYearStart()

virtual void icu::SimpleDateFormat::set2DigitYearStart | ( | UDate | d,
|  | UErrorCode & | status
| ) |  |
| virtual

Set the start UDate used to interpret two-digit year strings.

When dates are parsed having 2-digit year strings, they are placed within a assumed range of 100 years starting on the two digit start date. For example, the string "24-Jan-17" may be in the year 1817, 1917, 2017, or some other year. SimpleDateFormat chooses a year so that the resultant date is on or after the two digit start date and within 100 years of the two digit start date.

By default, the two digit start date is set to 80 years before the current time at which a SimpleDateFormat object is created.

Parameters

  d | start UDate used to interpret two-digit year strings.
  status | Filled in with U_ZERO_ERROR if the parse was successful, and with an error value if there was a parse error.

Stable:
  ICU 2.0

## ◆ setContext()

virtual void icu::SimpleDateFormat::setContext | ( | UDisplayContext | value,
|  | UErrorCode & | status
| ) |  |
| overridevirtual

Set a particular UDisplayContext value in the formatter, such as UDISPCTX_CAPITALIZATION_FOR_STANDALONE.

Note: For getContext, see DateFormat.

Parameters

  value | The UDisplayContext value to set.
  status | Input/output status. If at entry this indicates a failure status, the function will do nothing; otherwise this will be updated with any new status from the function.

Stable:
  ICU 53

Reimplemented from icu::DateFormat.

## ◆ setDateFormatSymbols()

virtual void icu::SimpleDateFormat::setDateFormatSymbols | ( | const DateFormatSymbols & | newFormatSymbols | ) |
| virtual

Set the date/time formatting data.

Parameters

  newFormatSymbols | the given date-time formatting symbols to copy.

Stable:
  ICU 2.0

## ◆ setTimeZoneFormat()

virtual void icu::SimpleDateFormat::setTimeZoneFormat | ( | const TimeZoneFormat & | newTimeZoneFormat | ) |
| virtual

Sets the TimeZoneFormat to be used by this date/time formatter.

Parameters

  newTimeZoneFormat | The TimeZoneFormat object to copy.

Internal:
  Do not use. This API is for internal use only. ICU 49 technology preview

## ◆ toLocalizedPattern()

virtual UnicodeString & icu::SimpleDateFormat::toLocalizedPattern | ( | UnicodeString & | result,
|  | UErrorCode & | status
| ) |  | const
| virtual

Return a localized pattern string describing this date format.

In most cases, this will return the same thing as toPattern(), but a locale can specify characters to use in pattern descriptions in place of the ones described in this class's class documentation. (Presumably, letters that would be more mnemonic in that locale's language.) This function would produce a pattern using those letters.

Note: This implementation depends on DateFormatSymbols::getLocalPatternChars() to get localized format pattern characters. ICU does not include localized pattern character data, therefore, unless user sets localized pattern characters manually, this method returns the same result as toPattern().

Parameters

  result | Receives the localized pattern.
  status | Output param set to success/failure code on exit. If the pattern is invalid, this will be set to a failure result.

Returns
  A reference to 'result'.

Stable:
  ICU 2.0

## ◆ toPattern()

virtual UnicodeString & icu::SimpleDateFormat::toPattern | ( | UnicodeString & | result | ) | const
| virtual

Return a pattern string describing this date format.

Parameters

  result | Output param to receive the pattern.

Returns
  A reference to 'result'.

Stable:
  ICU 2.0

## Friends And Related Symbol Documentation

## ◆ DateFormat

friend class DateFormat
| friend

Definition at line 1223 of file smpdtfmt.h.

## ◆ DateIntervalFormat

friend class DateIntervalFormat
| friend

Definition at line 1224 of file smpdtfmt.h.

The documentation for this class was generated from the following file:

- i18n/unicode/smpdtfmt.h